diff --git a/reviewboard/hostingsvcs/tests/test_assembla.py b/reviewboard/hostingsvcs/tests/test_assembla.py
index 652262c6c9c6d2f873e056d7856fe9bd4df2ef25..2c6989da3baaf072846bbf7dd18e21e87c678946 100644
--- a/reviewboard/hostingsvcs/tests/test_assembla.py
+++ b/reviewboard/hostingsvcs/tests/test_assembla.py
@@ -65,7 +65,7 @@
 
         self.assertFalse(service.is_authorized())
 
-        service.authorize('myuser', 'abc123', None)
+        service.authorize(username='myuser', password='abc123')
 
         self.assertIn('password', account.data)
         self.assertNotEqual(account.data['password'], 'abc123')
@@ -77,7 +77,7 @@
             account = self.create_hosting_account()
             service = account.service
 
-            service.authorize('myuser', 'abc123', None)
+            service.authorize(username='myuser', password='abc123')
 
             repository = self.create_repository(hosting_account=account,
                                                 tool_name='Perforce')
@@ -105,7 +105,7 @@
             account = self.create_hosting_account()
             service = account.service
 
-            service.authorize('myuser', 'abc123', None)
+            service.authorize(username='myuser', password='abc123')
 
             repository = self.create_repository(
                 path='https://svn.example.com/',
diff --git a/reviewboard/hostingsvcs/tests/test_beanstalk.py b/reviewboard/hostingsvcs/tests/test_beanstalk.py
index 32df5296261449216fed7d9636843484dfb1df44..84581292277d29c9c184226ef833a967a942235e 100644
--- a/reviewboard/hostingsvcs/tests/test_beanstalk.py
+++ b/reviewboard/hostingsvcs/tests/test_beanstalk.py
@@ -65,7 +65,7 @@
 
         self.assertFalse(service.is_authorized())
 
-        service.authorize('myuser', 'abc123', None)
+        service.authorize(username='myuser', password='abc123')
 
         self.assertIn('password', account.data)
         self.assertNotEqual(account.data['password'], 'abc123')
diff --git a/reviewboard/hostingsvcs/tests/test_client.py b/reviewboard/hostingsvcs/tests/test_client.py
index 0ddc12234444074db4b70726a47d004b9b5c714a..491bfe2bea15c6291e45339fe620991773d7998e 100644
--- a/reviewboard/hostingsvcs/tests/test_client.py
+++ b/reviewboard/hostingsvcs/tests/test_client.py
@@ -2,9 +2,8 @@
 
 from __future__ import annotations
 
-from typing import List
+from typing import TYPE_CHECKING
 
-from djblets.testing.testcases import ExpectedWarning
 from kgb import SpyAgency
 
 from reviewboard.deprecation import RemovedInReviewBoard80Warning
@@ -15,12 +14,15 @@
 from reviewboard.testing.hosting_services import TestService
 from reviewboard.testing.testcase import TestCase
 
-
-class DummyHTTPRequest(HostingServiceHTTPRequest):
-    def open(self):
+if TYPE_CHECKING:
+    from djblets.testing.testcases import ExpectedWarning
+
+
+class _DummyHTTPRequest(HostingServiceHTTPRequest):
+    def open(self) -> HostingServiceHTTPResponse:
         method = self.method
 
-        if method in ('DELETE', 'HEAD'):
+        if method in {'DELETE', 'HEAD'}:
             data = None
         else:
             data = b'{"key": "test response"}'
@@ -37,7 +39,7 @@
             url=self.url,
             data=data,
             headers={
-                str('Test-header'): str('Value'),
+                'Test-header': 'Value',
             },
             status_code=status_code)
 
@@ -45,7 +47,7 @@
 class HostingServiceHTTPRequestTests(TestCase):
     """Unit tests for HostingServiceHTTPRequest."""
 
-    def test_init_with_query(self):
+    def test_init_with_query(self) -> None:
         """Testing HostingServiceHTTPRequest construction with query="""
         request = HostingServiceHTTPRequest(
             url='http://example.com?z=1&z=2&baz=true',
@@ -60,27 +62,27 @@
             'http://example.com?a=10&baz=true&foo=bar&list=a&list=b&list=c'
             '&z=1&z=2')
 
-    def test_init_with_body_not_bytes(self):
+    def test_init_with_body_not_bytes(self) -> None:
         """Testing HostingServiceHTTPRequest construction with non-bytes body
         """
         account = HostingServiceAccount()
         service = TestService(account)
 
         expected_message = (
-            'Received non-bytes body for the HTTP request for %r. This is '
-            'likely an implementation problem. Please make sure only byte '
-            'strings are sent for the request body.'
-            % TestService
+            f'Received non-bytes body for the HTTP request for '
+            f'{TestService!r}. This is likely an implementation problem. '
+            f'Please make sure only byte strings are sent for the request '
+            f'body.'
         )
 
         with self.assertRaisesMessage(TypeError, expected_message):
             HostingServiceHTTPRequest(
                 url='http://example.com?z=1&z=2&baz=true',
                 method='POST',
-                body=123,
+                body=123,  # type:ignore
                 hosting_service=service)
 
-    def test_init_with_header_key_not_unicode(self):
+    def test_init_with_header_key_not_unicode(self) -> None:
         """Testing HostingServiceHTTPRequest construction with non-Unicode
         header key
         """
@@ -88,22 +90,22 @@
         service = TestService(account)
 
         expected_message = (
-            'Received non-Unicode header %r (value=%r) for the HTTP request '
-            'for %r. This is likely an implementation problem. Please make '
-            'sure only Unicode strings are sent in request headers.'
-            % (b'My-Header', 'abc', TestService)
+            f"Received non-Unicode header name b'My-Header' (value='abc') for "
+            f"the HTTP request for {TestService!r}. This is likely an "
+            f"implementation problem. Please make sure only Unicode strings "
+            f"are sent in request headers."
         )
 
         with self.assertRaisesMessage(TypeError, expected_message):
             HostingServiceHTTPRequest(
                 url='http://example.com?z=1&z=2&baz=true',
                 method='POST',
-                headers={
+                headers={  # type:ignore
                     b'My-Header': 'abc',
                 },
                 hosting_service=service)
 
-    def test_init_with_header_value_not_unicode(self):
+    def test_init_with_header_value_not_unicode(self) -> None:
         """Testing HostingServiceHTTPRequest construction with non-Unicode
         header value
         """
@@ -111,22 +113,22 @@
         service = TestService(account)
 
         expected_message = (
-            'Received non-Unicode header %r (value=%r) for the HTTP request '
-            'for %r. This is likely an implementation problem. Please make '
-            'sure only Unicode strings are sent in request headers.'
-            % ('My-Header', b'abc', TestService)
+            f"Received non-Unicode header value for 'My-Header' "
+            f"(value=b'abc') for the HTTP request for {TestService!r}. This "
+            f"is likely an implementation problem. Please make sure only "
+            f"Unicode strings are sent in request headers."
         )
 
         with self.assertRaisesMessage(TypeError, expected_message):
             HostingServiceHTTPRequest(
                 url='http://example.com?z=1&z=2&baz=true',
                 method='POST',
-                headers={
+                headers={  # type:ignore
                     'My-Header': b'abc',
                 },
                 hosting_service=service)
 
-    def test_add_basic_auth(self):
+    def test_add_basic_auth(self) -> None:
         """Testing HostingServiceHTTPRequest.add_basic_auth"""
         request = HostingServiceHTTPRequest('http://example.com')
         request.add_basic_auth(b'username', b'password')
@@ -137,7 +139,7 @@
                 'Authorization': 'Basic dXNlcm5hbWU6cGFzc3dvcmQ=',
             })
 
-    def test_get_header(self):
+    def test_get_header(self) -> None:
         """Testing HostingServiceHTTPRequest.get_header"""
         request = HostingServiceHTTPRequest(
             'http://example.com',
@@ -158,7 +160,7 @@
 class HostingServiceHTTPResponseTests(TestCase):
     """Unit tests for HostingServiceHTTPResponse."""
 
-    def test_json(self):
+    def test_json(self) -> None:
         """Testing HostingServiceHTTPResponse.json"""
         request = HostingServiceHTTPRequest('http://example.com')
         response = HostingServiceHTTPResponse(request=request,
@@ -173,7 +175,7 @@
                 'b': 2,
             })
 
-    def test_json_with_non_json_response(self):
+    def test_json_with_non_json_response(self) -> None:
         """Testing HostingServiceHTTPResponse.json with non-JSON response"""
         request = HostingServiceHTTPRequest('http://example.com')
         response = HostingServiceHTTPResponse(request=request,
@@ -185,7 +187,7 @@
         with self.assertRaises(ValueError):
             response.json
 
-    def test_get_header(self):
+    def test_get_header(self) -> None:
         """Testing HostingServiceHTTPRequest.get_header"""
         request = HostingServiceHTTPRequest('http://example.com')
         response = HostingServiceHTTPResponse(
@@ -194,8 +196,8 @@
             status_code=200,
             data=b'',
             headers={
-                str('Authorization'): str('Basic abc123'),
-                str('Content-Length'): str('123'),
+                'Authorization': 'Basic abc123',
+                'Content-Length': '123',
             })
 
         self.assertEqual(response.get_header('Authorization'), 'Basic abc123')
@@ -216,21 +218,23 @@
     #:     reviewboard.hostingsvcs.base.client.HostingServiceClient
     client: HostingServiceClient
 
-    def setUp(self):
+    def setUp(self) -> None:
+        """Set up the test case."""
         super().setUp()
 
         account = HostingServiceAccount()
         service = TestService(account)
 
         self.client = HostingServiceClient(service)
-        self.client.http_request_cls = DummyHTTPRequest
+        self.client.http_request_cls = _DummyHTTPRequest
 
     def tearDown(self) -> None:
+        """Tear down the test case."""
         super().tearDown()
 
         self.client = None  # type: ignore
 
-    def test_http_delete(self):
+    def test_http_delete(self) -> None:
         """Testing HostingServiceClient.http_delete"""
         self.spy_on(self.client.build_http_request)
 
@@ -243,18 +247,18 @@
             password='password')
 
         self.assertIsInstance(response, HostingServiceHTTPResponse)
-        self.assertIsNone(response.data)
+        self.assertEqual(response.data, b'')
         self.assertEqual(response.url, 'http://example.com')
         self.assertEqual(response.status_code, 204)
         self.assertIsInstance(response.headers, dict)
         self.assertEqual(
             response.headers,
             {
-                str('Test-header'): str('Value'),
+                'Test-header': 'Value',
             })
 
         # One for each item in the tuple, + 1 to detect the bounds.
-        expected_warnings: List[ExpectedWarning] = [
+        expected_warnings: list[ExpectedWarning] = [
             {
                 'cls': RemovedInReviewBoard80Warning,
                 'message': (
@@ -264,7 +268,7 @@
                     'be removed in Review Board 8.'
                 ),
             }
-            for i in range(3)
+            for _i in range(3)
         ]
 
         with self.assertWarnings(expected_warnings):
@@ -297,7 +301,7 @@
                 'Foo': 'bar',
             })
 
-    def test_http_get(self):
+    def test_http_get(self) -> None:
         """Testing HostingServiceClient.http_get"""
         self.spy_on(self.client.build_http_request)
 
@@ -317,11 +321,11 @@
         self.assertEqual(
             response.headers,
             {
-                str('Test-header'): str('Value'),
+                'Test-header': 'Value',
             })
 
         # One for each item in the tuple, + 1 to detect the bounds.
-        expected_warnings: List[ExpectedWarning] = [
+        expected_warnings: list[ExpectedWarning] = [
             {
                 'cls': RemovedInReviewBoard80Warning,
                 'message': (
@@ -331,7 +335,7 @@
                     'be removed in Review Board 8.'
                 ),
             }
-            for i in range(3)
+            for _i in range(3)
         ]
 
         with self.assertWarnings(expected_warnings):
@@ -363,7 +367,7 @@
                 'Foo': 'bar',
             })
 
-    def test_http_head(self):
+    def test_http_head(self) -> None:
         """Testing HostingServiceClient.http_head"""
         self.spy_on(self.client.build_http_request)
 
@@ -376,18 +380,18 @@
             password='password')
 
         self.assertIsInstance(response, HostingServiceHTTPResponse)
-        self.assertIsNone(response.data)
+        self.assertEqual(response.data, b'')
         self.assertEqual(response.url, 'http://example.com')
         self.assertEqual(response.status_code, 200)
         self.assertIsInstance(response.headers, dict)
         self.assertEqual(
             response.headers,
             {
-                str('Test-header'): str('Value'),
+                'Test-header': 'Value',
             })
 
         # One for each item in the tuple, + 1 to detect the bounds.
-        expected_warnings: List[ExpectedWarning] = [
+        expected_warnings: list[ExpectedWarning] = [
             {
                 'cls': RemovedInReviewBoard80Warning,
                 'message': (
@@ -397,7 +401,7 @@
                     'be removed in Review Board 8.'
                 ),
             }
-            for i in range(3)
+            for _i in range(3)
         ]
 
         with self.assertWarnings(expected_warnings):
@@ -429,13 +433,13 @@
                 'Foo': 'bar',
             })
 
-    def test_http_post_with_body_unicode(self):
+    def test_http_post_with_body_unicode(self) -> None:
         """Testing HostingServiceClient.http_post with body as Unicode"""
         self.spy_on(self.client.build_http_request)
 
         response = self.client.http_post(
             url='http://example.com',
-            body='test body\U0001f60b',
+            body='test body\U0001f60b'.encode('utf-8'),
             headers={
                 'Foo': 'bar',
             },
@@ -450,11 +454,11 @@
         self.assertEqual(
             response.headers,
             {
-                str('Test-header'): str('Value'),
+                'Test-header': 'Value',
             })
 
         # One for each item in the tuple, + 1 to detect the bounds.
-        expected_warnings: List[ExpectedWarning] = [
+        expected_warnings: list[ExpectedWarning] = [
             {
                 'cls': RemovedInReviewBoard80Warning,
                 'message': (
@@ -464,7 +468,7 @@
                     'be removed in Review Board 8.'
                 ),
             }
-            for i in range(3)
+            for _i in range(3)
         ]
 
         with self.assertWarnings(expected_warnings):
@@ -498,7 +502,7 @@
                 'Foo': 'bar',
             })
 
-    def test_http_post_with_body_bytes(self):
+    def test_http_post_with_body_bytes(self) -> None:
         """Testing HostingServiceClient.http_post with body as bytes"""
         self.spy_on(self.client.build_http_request)
 
@@ -519,11 +523,11 @@
         self.assertEqual(
             response.headers,
             {
-                str('Test-header'): str('Value'),
+                'Test-header': 'Value',
             })
 
         # One for each item in the tuple, + 1 to detect the bounds.
-        expected_warnings: List[ExpectedWarning] = [
+        expected_warnings: list[ExpectedWarning] = [
             {
                 'cls': RemovedInReviewBoard80Warning,
                 'message': (
@@ -533,7 +537,7 @@
                     'be removed in Review Board 8.'
                 ),
             }
-            for i in range(3)
+            for _i in range(3)
         ]
 
         with self.assertWarnings(expected_warnings):
@@ -567,7 +571,7 @@
                 'Foo': 'bar',
             })
 
-    def test_http_put_with_body_unicode(self):
+    def test_http_put_with_body_unicode(self) -> None:
         """Testing HostingServiceClient.http_put with body as Unicode"""
         self.spy_on(self.client.build_http_request)
 
@@ -588,11 +592,11 @@
         self.assertEqual(
             response.headers,
             {
-                str('Test-header'): str('Value'),
+                'Test-header': 'Value',
             })
 
         # One for each item in the tuple, + 1 to detect the bounds.
-        expected_warnings: List[ExpectedWarning] = [
+        expected_warnings: list[ExpectedWarning] = [
             {
                 'cls': RemovedInReviewBoard80Warning,
                 'message': (
@@ -602,7 +606,7 @@
                     'be removed in Review Board 8.'
                 ),
             }
-            for i in range(3)
+            for _i in range(3)
         ]
 
         with self.assertWarnings(expected_warnings):
@@ -636,7 +640,7 @@
                 'Foo': 'bar',
             })
 
-    def test_http_put_with_body_bytes(self):
+    def test_http_put_with_body_bytes(self) -> None:
         """Testing HostingServiceClient.http_put with body as bytes"""
         self.spy_on(self.client.build_http_request)
 
@@ -657,11 +661,11 @@
         self.assertEqual(
             response.headers,
             {
-                str('Test-header'): str('Value'),
+                'Test-header': 'Value',
             })
 
         # One for each item in the tuple, + 1 to detect the bounds.
-        expected_warnings: List[ExpectedWarning] = [
+        expected_warnings: list[ExpectedWarning] = [
             {
                 'cls': RemovedInReviewBoard80Warning,
                 'message': (
@@ -671,7 +675,7 @@
                     'be removed in Review Board 8.'
                 ),
             }
-            for i in range(3)
+            for _i in range(3)
         ]
 
         with self.assertWarnings(expected_warnings):
@@ -705,7 +709,7 @@
                 'Foo': 'bar',
             })
 
-    def test_http_request(self):
+    def test_http_request(self) -> None:
         """Testing HostingServiceClient.http_request"""
         self.spy_on(self.client.build_http_request)
 
@@ -727,11 +731,11 @@
         self.assertEqual(
             response.headers,
             {
-                str('Test-header'): str('Value'),
+                'Test-header': 'Value',
             })
 
         # One for each item in the tuple, + 1 to detect the bounds.
-        expected_warnings: List[ExpectedWarning] = [
+        expected_warnings: list[ExpectedWarning] = [
             {
                 'cls': RemovedInReviewBoard80Warning,
                 'message': (
@@ -741,7 +745,7 @@
                     'be removed in Review Board 8.'
                 ),
             }
-            for i in range(3)
+            for _i in range(3)
         ]
 
         with self.assertWarnings(expected_warnings):
@@ -773,7 +777,7 @@
                 'Foo': 'bar',
             })
 
-    def test_build_http_request(self):
+    def test_build_http_request(self) -> None:
         """Testing HostingServiceClient.build_http_request"""
         request = self.client.build_http_request(
             url='http://example.com',
@@ -793,7 +797,7 @@
                 'Foo': 'bar',
             })
 
-    def test_build_http_request_with_basic_auth(self):
+    def test_build_http_request_with_basic_auth(self) -> None:
         """Testing HostingServiceClient.build_http_request with username and
         password
         """
@@ -819,7 +823,7 @@
                 'Foo': 'bar',
             })
 
-    def test_json_delete(self):
+    def test_json_delete(self) -> None:
         """Testing HostingServiceClient.json_delete"""
         self.spy_on(self.client.build_http_request)
 
@@ -838,12 +842,12 @@
                 username='username',
                 password='password')
 
-        self.assertIsNone(rsp)
+        self.assertEqual(rsp, b'')
         self.assertIsInstance(headers, dict)
         self.assertEqual(
             headers,
             {
-                str('Test-header'): str('Value'),
+                'Test-header': 'Value',
             })
 
         self.assertSpyCalledWith(
@@ -870,7 +874,7 @@
                 'Foo': 'bar',
             })
 
-    def test_json_get(self):
+    def test_json_get(self) -> None:
         """Testing HostingServiceClient.json_get"""
         self.spy_on(self.client.build_http_request)
 
@@ -898,7 +902,7 @@
         self.assertEqual(
             headers,
             {
-                str('Test-header'): str('Value'),
+                'Test-header': 'Value',
             })
 
         self.assertSpyCalledWith(
@@ -924,7 +928,7 @@
                 'Foo': 'bar',
             })
 
-    def test_json_post_with_body_unicode(self):
+    def test_json_post_with_body_unicode(self) -> None:
         """Testing HostingServiceClient.json_post with body as Unicode"""
         self.spy_on(self.client.build_http_request)
 
@@ -953,7 +957,7 @@
         self.assertEqual(
             headers,
             {
-                str('Test-header'): str('Value'),
+                'Test-header': 'Value',
             })
 
         self.assertSpyCalledWith(
@@ -981,7 +985,7 @@
                 'Foo': 'bar',
             })
 
-    def test_json_post_with_body_bytes(self):
+    def test_json_post_with_body_bytes(self) -> None:
         """Testing HostingServiceClient.json_post with body as bytes"""
         self.spy_on(self.client.build_http_request)
 
@@ -1010,7 +1014,7 @@
         self.assertEqual(
             headers,
             {
-                str('Test-header'): str('Value'),
+                'Test-header': 'Value',
             })
 
         self.assertSpyCalledWith(
diff --git a/reviewboard/hostingsvcs/tests/test_gitlab.py b/reviewboard/hostingsvcs/tests/test_gitlab.py
index 0f44e38eda9d281aaffdb88cc0674d8c7b08555f..2e1f7c6c28b7871c7e41b5cbfda5842d4548af94 100644
--- a/reviewboard/hostingsvcs/tests/test_gitlab.py
+++ b/reviewboard/hostingsvcs/tests/test_gitlab.py
@@ -362,7 +362,7 @@
                                   hosting_account=hosting_account) as ctx:
             with self.assertRaisesMessage(GitLabAPIVersionError, message):
                 ctx.service.authorize(
-                    'myuser',
+                    username='myuser',
                     credentials={
                         'username': 'myuser',
                         'private_token': 'foobarbaz',
@@ -1303,7 +1303,7 @@
         with self.setup_http_test(hosting_account=hosting_account,
                                   *args, **kwargs) as ctx:
             ctx.service.authorize(
-                'myuser',
+                username='myuser',
                 credentials={
                     'username': 'myuser',
                     'private_token': 'foobarbaz',
diff --git a/reviewboard/hostingsvcs/tests/test_registration.py b/reviewboard/hostingsvcs/tests/test_registration.py
index 77e6d6fbde7481e2dbec7363eed7621648ffdbd4..5afa214edb3d5fc7117ef3c19c4c8334061e1167 100644
--- a/reviewboard/hostingsvcs/tests/test_registration.py
+++ b/reviewboard/hostingsvcs/tests/test_registration.py
@@ -1,27 +1,55 @@
+"""Unit tests for Hosting Service registration."""
+
+from __future__ import annotations
+
+from typing import TYPE_CHECKING
+
 from django.http import HttpResponse
 from django.urls import NoReverseMatch, path
 from djblets.registries.errors import AlreadyRegisteredError, ItemLookupError
 
-from reviewboard.hostingsvcs.base import BaseHostingService
+from reviewboard.deprecation import RemovedInReviewBoard90Warning
+from reviewboard.hostingsvcs.base.hosting_service import BaseHostingService
+from reviewboard.hostingsvcs.base.registry import hosting_service_registry
 from reviewboard.hostingsvcs.service import (register_hosting_service,
                                              unregister_hosting_service)
 from reviewboard.site.urlresolvers import local_site_reverse
 from reviewboard.testing import TestCase
 
-
-def hosting_service_url_test_view(request, repo_id):
-    """View to test URL pattern addition when registering a hosting service"""
+if TYPE_CHECKING:
+    from django.http import HttpRequest
+
+
+def hosting_service_url_test_view(
+    request: HttpRequest,
+    repo_id: int,
+) -> HttpResponse:
+    """View to test URL pattern addition when registering a hosting service.
+
+    Args:
+        request (django.http.HttpRequest):
+            The HTTP request.
+
+        repo_id (int):
+            The ID of the repository.
+
+    Returns:
+        django.http.HttpResponse:
+        A fake response.
+    """
     return HttpResponse(str(repo_id))
 
 
 class HostingServiceRegistrationTests(TestCase):
     """Unit tests for Hosting Service registration."""
 
-    class DummyService(BaseHostingService):
+    class _DummyService(BaseHostingService):
         name = 'DummyService'
+        hosting_service_id = 'dummy-service'
 
-    class DummyServiceWithURLs(BaseHostingService):
+    class _DummyServiceWithURLs(BaseHostingService):
         name = 'DummyServiceWithURLs'
+        hosting_service_id = 'dummy-service'
 
         repository_url_patterns = [
             path('hooks/pre-commit/',
@@ -29,33 +57,34 @@
                  name='dummy-service-post-commit-hook'),
         ]
 
-    def tearDown(self):
-        super(HostingServiceRegistrationTests, self).tearDown()
+    def tearDown(self) -> None:
+        """Tear down the test case."""
+        super().tearDown()
 
         # Unregister the service, going back to a default state. It's okay
         # if it fails.
         #
         # This will match whichever service we added for testing.
         try:
-            unregister_hosting_service('dummy-service')
+            hosting_service_registry.unregister_by_id('dummy-service')
         except ItemLookupError:
             pass
 
-    def test_register_without_urls(self):
+    def test_register_without_urls(self) -> None:
         """Testing HostingService registration"""
-        register_hosting_service('dummy-service', self.DummyService)
+        hosting_service_registry.register(self._DummyService)
 
         with self.assertRaises(AlreadyRegisteredError):
-            register_hosting_service('dummy-service', self.DummyService)
+            hosting_service_registry.register(self._DummyService)
 
-    def test_unregister(self):
+    def test_unregister(self) -> None:
         """Testing HostingService unregistration"""
-        register_hosting_service('dummy-service', self.DummyService)
-        unregister_hosting_service('dummy-service')
+        hosting_service_registry.register(self._DummyService)
+        hosting_service_registry.unregister(self._DummyService)
 
-    def test_registration_with_urls(self):
+    def test_registration_with_urls(self) -> None:
         """Testing HostingService registration with URLs"""
-        register_hosting_service('dummy-service', self.DummyServiceWithURLs)
+        hosting_service_registry.register(self._DummyServiceWithURLs)
 
         self.assertEqual(
             local_site_reverse(
@@ -76,15 +105,14 @@
                 }),
             '/s/test-site/repos/1/dummy-service/hooks/pre-commit/')
 
-        # Once registered, should not be able to register again
+        # Once registered, should not be able to register again.
         with self.assertRaises(AlreadyRegisteredError):
-            register_hosting_service('dummy-service',
-                                     self.DummyServiceWithURLs)
+            hosting_service_registry.register(self._DummyServiceWithURLs)
 
-    def test_unregistration_with_urls(self):
+    def test_unregistration_with_urls(self) -> None:
         """Testing HostingService unregistration with URLs"""
-        register_hosting_service('dummy-service', self.DummyServiceWithURLs)
-        unregister_hosting_service('dummy-service')
+        hosting_service_registry.register(self._DummyServiceWithURLs)
+        hosting_service_registry.unregister(self._DummyServiceWithURLs)
 
         with self.assertRaises(NoReverseMatch):
             local_site_reverse(
@@ -92,8 +120,30 @@
                 kwargs={
                     'repository_id': 1,
                     'hosting_service_id': 'dummy-service',
-                }),
+                })
 
-        # Once unregistered, should not be able to unregister again
+        # Once unregistered, should not be able to unregister again.
         with self.assertRaises(ItemLookupError):
+            hosting_service_registry.unregister(self._DummyServiceWithURLs)
+
+    def test_legacy_register_methods(self) -> None:
+        """Testing legacy register and unregister methods"""
+        message = (
+            '`reviewboard.hostingsvcs.service.register_hosting_service()` '
+            'has moved to `reviewboard.hostingsvcs.base.registry.'
+            'HostingServiceRegistry.register`. The old function is '
+            'deprecated and will be removed in Review Board 9.0.'
+        )
+
+        with self.assertWarns(RemovedInReviewBoard90Warning, message):
+            register_hosting_service('dummy-service', self._DummyService)
+
+        message = (
+            '`reviewboard.hostingsvcs.service.unregister_hosting_service()` '
+            'has moved to `reviewboard.hostingsvcs.base.registry.'
+            'HostingServiceRegistry.unregister_by_id`. The old function is '
+            'deprecated and will be removed in Review Board 9.0.'
+        )
+
+        with self.assertWarns(RemovedInReviewBoard90Warning, message):
             unregister_hosting_service('dummy-service')
